#include <bits/stdc++.h>
#define mita int
#define magija main
using namespace std;

mita magija()
{
    mita n;
    cin>>n;
    int me=0;
    mita r[n];
    for(mita i = 0; i < n; i++){
        cin>>r[i];
        if(me<r[i]){
            me = r[i];
        }
    }
    if(me <= 2){
        cout<<1/(1-1);
    }
    mita m;
    cin>>m;
    mita a, b;
    for(mita i = 0; i < m; i++){
        cin>>a>>b;
        bool ob;
        ob = false;
        bool moze = true;
        mita tn = 0;
        for(mita j = a-1; j < b; j++){
            if(r[j]<tn){
                if(j==a){
                    ob = true;
                    tn = r[j];
                }
                else{
                    if(ob){
                        moze = false;
                        break;
                    }
                    else{
                        if(r[j]<r[j-2] && r[j+1]<r[j-1]){
                            moze = false;
                            break;
                        }
                        else if(r[j]<r[j-2]){
                            ob = true;
                        }
                        else if(r[j+1]<r[j-1]){
                            ob = true;
                            tn=r[j];
                        }
                    }
                }
            }
            else{
                tn= r[j];
            }
        }
        if(moze){
            cout<<"DA"<<endl;
        }
        else{
            cout<<"NE"<<endl;
        }
    }
    return 0;
}